//
//  pxg.java
//  Treehousestudio
//
//  Created by john maeda on Wed Aug 14 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

// optimization proposal for alpha blending
// create a byte lookup table for a smaller color space (gray)
// that can calculate the right overwrite color when rendered in gray

// byte lut[16][16][16] (4K); 32 is 32K

import java.applet.Applet;
import java.util.*;
import java.awt.*;
import java.awt.image.*;
 

public class pxg {
	int cbw, cbh;
	int cbt;
	Image im;
	Component p;
	final int pxg_mode8 =8 , pxg_mode24 = 24;
	int col; 
	
	MemoryImageSource ms;
	int mode = pxg_mode24; // 
	public pxg(int w, int h, Component _p)
	{
		cbw = w; cbh = h;
		cbt = w*h;
		p = _p;
		setClip(0,0,w,h);
	}

	public void setgray(int g)
	{
	}	
	public void setColor(Color c)
	{
         int r, g, b;
         r=c.getRed();g=c.getGreen();b=c.getBlue();
		setrgb(r,g,b);//(int)(r*255),(int)(g*255),(int)(b*255));
	}
	
	public void setrgb(int r, int g, int b)
	{
	}	
	public void fade2white(int level)
	{
	}
	public void fade2black(int level)
	{
	}
	public void drawRect(int x, int y, int w, int h)
	{
	}
	public void fillRect(int x, int y, int w, int h)
	{
	}
	public void invertRect(int x, int y, int w, int h)
	{
	}
	public void brightenRect(int x, int y, int w, int h)
	{
	}
	public void darkenRect(int x, int y, int w, int h)
	{
	}
	public void draw(Graphics g, int x, int y)
	{
		ms.newPixels();
		g.drawImage(im,x,y,p);
	}
	public void draw(Graphics g, int x, int y, int w, int h)
	{
		ms.newPixels();
		g.drawImage(im,x,y,w,h,p);
	}
	public void blt(int[] b, int sx, int sy, int w, int h, int x, int y)
	{
	}
	public void copyfrompxg(pxg p)
	{
	}
	
	int clipx1, clipy1, clipx2, clipy2;
	public void setClip(int x, int y, int w, int h)
	{
		clipx1 = x; clipx2 = x+w; clipy1 = y; clipy2 = y+h;
	}
	public void line(int x1, int y1, int x2, int y2)
	{
	}
}

class pxg8 extends pxg {
	IndexColorModel imc;
	byte []b;
	
	byte []lbuf;
   
	// build alphalut
	byte alut[][][];
	byte mlut[][][]; // scaling table to map values of background to foreground
	
	public void copyfrompxg(pxg pp)
	{
		pxg8 p = (pxg8)pp;
		// this assumes a great leap of faith
		System.arraycopy(p.b,0,b,0,cbt);
	}
	
	public void fade2white(int level)
	{
		// this only works with a lut
		int i;
		for(i=0;i<cbt;i++) {
			if ((0xff&b[i])<level) b[i] = (byte)(level&0xff);
		}
	}

	public void fade2black(int level)
	{
		// this only works with a lut
		int i;
		for(i=0;i<cbt;i++) {
			if ((0xff&b[i])>level) b[i] = (byte)(level&0xff);
		}
	}

	public void buildalut()
	{
		// 2, 4, 6, 8, 16, 32 >> 6
		// 64, 128, 256
		int i, j, k;
		int alpha, src, dest;
		alut = new byte[64][64][64];
		float f;
		
		// alpha, src, dest
		for(i=0;i<64;i++)
			for(j=0;j<64;j++) {
				for(k=0;k<64;k++) {
					// a*s + (1-a)*d
					// d+(s-d)*a
					alpha = i<<2; src = j<<2; dest = k<<2; 
//					f = dest+(src-dest)*alpha/(float)(63<<2);
//					alut[63-i][j][k] = (byte)((int)(f+.5f));//dest+(src-dest)*alpha/(63<<2));
					alut[63-i][j][k] = (byte)(dest+(src-dest)*alpha/(63<<2));
//					alut[63-i][j][k] = (byte)(dest+(src-dest)*alpha/(63<<2));
				//	if (i==1)
					//System.out.print("["+alpha+","+src+","+dest+"/ "+(int)(alut[i][j][k]&0x0ff)+"],");
				}
				//if (i==1)
				//System.out.println("");
			}
		mlut = new byte[64][64][64];
		for(i=0;i<64;i++)
			for(j=0;j<64;j++) {
				for(k=0;k<64;k++) {
					// a*s + (1-a)*d
					// d+(s-d)*a
					alpha = i<<2; src = j<<2; dest = k<<2; 
//					f = dest+(src-dest)*alpha/(float)(63<<2);
//					alut[63-i][j][k] = (byte)((int)(f+.5f));//dest+(src-dest)*alpha/(63<<2));
					mlut[i][j][k] = (byte)(src*dest/(63<<2)*alpha/(63<<2));//dest+(src-dest)*alpha/(63<<2));
				//	if (i==1)
					//System.out.print("["+alpha+","+src+","+dest+"/ "+(int)(alut[i][j][k]&0x0ff)+"],");
				}
				//if (i==1)
				//System.out.println("");
			}
		System.out.println("* alpha lut built");
	}

	public pxg8(int w, int h, Component p)
	{
		super(w,h,p);
		
		{
			byte gs[] = new byte[256];
			byte gs2[] = new byte[256];
			int i; for(i=0;i<256;i++) { gs2[i] = (byte)0xff; gs[i] = (byte)(i&0xff);}
			imc = new IndexColorModel(8,256, // bits, size
				gs,gs,gs // equivalent values for red,green, blue
				);  // can specify here a transparencyindex
		}
		b = new byte[cbt];
		ms = new MemoryImageSource(cbw,cbh,imc,b,0,cbw);
		ms.setAnimated(true);
      ms.setFullBufferUpdates(false);
		im = p.createImage(ms);
		lbuf = new byte[cbw];
		mode = pxg_mode8;
		System.out.println("--> using pxg8 new");
		buildalut();
	}
	public void setrgb(int r, int g, int b)
	{
			// just take red
		setgray(r);
	}	

	public void setgray(int b) { if (b<0) b = 0; if (b>255) b = 255; col = b; }
	public void drawRect(int x, int y, int w, int h)
	{
		fillRect(x,y,w,1);
		fillRect(x,y+h-1,w,1);
		fillRect(x,y,1,h);
		fillRect(x+w-1,y,1,h);
		
	}
	public void fillRect(int x, int y, int w, int h)
	{
		byte bcol = (byte)col;
		
		if (x<clipx1 && (x+w)<clipx1) return;
		if (y<clipy1 && (y+h)<clipy1) return;
		if (x>clipx2 || y>clipy2) return;
		
		if (x<0) { w+=x; x = 0;} 
		if (y<0) { h+=y;  y= 0;}
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		
		int i,j,x2 = x+w, y2 = y+h, k;
		for(i=x; i<x2; i++) 
			lbuf[i] = bcol;
		for(j=y, k = y*cbw+x; j<y2; j++, k+= cbw)
			System.arraycopy(lbuf,x,b,k,w);
	}


	public void invertRect(int x, int y, int w, int h)
	{
		byte bcol = (byte)col;
		
		if (x<clipx1 && (x+w)<clipx1) return;
		if (y<clipy1 && (y+h)<clipy1) return;
		if (x>clipx2 || y>clipy2) return;
		
		if (x<0) { w+=x; x = 0;} 
		if (y<0) { h+=y;  y= 0;}
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		
		int i,j,x2 = x+w, y2 = y+h, k;

		for(j=y, k = y*cbw+x;j<y2;j++,k+=cbw) {
			for(i=0;i<w;i++) {
				b[k+i] = (byte)(255-(0xff&b[k+i]));//(byte)(255-0xff&b[k+i]);
			}
		}
	}
	
	public void brightenRect(int x, int y, int w, int h)
	{
		byte bcol = (byte)col;
		
		if (x<clipx1 && (x+w)<clipx1) return;
		if (y<clipy1 && (y+h)<clipy1) return;
		if (x>clipx2 || y>clipy2) return;
		
		if (x<0) { w+=x; x = 0;} 
		if (y<0) { h+=y;  y= 0;}
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		
		int i,j,x2 = x+w, y2 = y+h, k;

		for(j=y, k = y*cbw+x;j<y2;j++,k+=cbw) {
			for(i=0;i<w;i++) {
//				if (b[k+i]==127) return;
				b[k+i] = (byte)(127+(0xff&b[k+i])/4);//(byte)(255-0xff&b[k+i]);
			}
		}
	}

	public void darkenRect(int x, int y, int w, int h)
	{
		byte bcol = (byte)col;
		
		if (x<clipx1 && (x+w)<clipx1) return;
		if (y<clipy1 && (y+h)<clipy1) return;
		if (x>clipx2 || y>clipy2) return;
		
		if (x<0) { w+=x; x = 0;} 
		if (y<0) { h+=y;  y= 0;}
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		
		int i,j,x2 = x+w, y2 = y+h, k;

		for(j=y, k = y*cbw+x;j<y2;j++,k+=cbw) {
			for(i=0;i<w;i++) {
//				if (b[k+i]==127) return;
				b[k+i] = (byte)(127+63+(0xff&b[k+i])/4);//(byte)(255-0xff&b[k+i]);
			}
		}
	}
	public void fadeRect(int x, int y, int w, int h)
	{
		byte bcol = (byte)col;
		
		if (x<clipx1 && (x+w)<clipx1) return;
		if (y<clipy1 && (y+h)<clipy1) return;
		if (x>clipx2 || y>clipy2) return;
		
		if (x<0) { w+=x; x = 0;} 
		if (y<0) { h+=y;  y= 0;}
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		
		int i,j,x2 = x+w, y2 = y+h, k;
		for(i=x; i<x2; i++) 
			lbuf[i] = bcol;
		for(j=y, k = y*cbw+x; j<y2; j++, k+= cbw)
			System.arraycopy(lbuf,x,b,k,w);
	}
	

	public void setDot(int x, int y, int val) {
		int checkX, checkY, checkVal;

		if(x<0 || x>cbw || y<0 || y>cbh) return;
		if(val < 0) checkVal = 0;
		else if (val > 255) checkVal = 255;
		else checkVal = val;

		b[x+y*cbw] = (byte)(0xff&checkVal);
	}

	void intensifyPixel(int x, int y, float dist) {
		int oldVal, newVal, val, index;
		
		/* all this bounds checking goes away if we just clip the line .... */
		
		if(x<0 || x>=cbw || y<0 || y>=cbh) return;
		if(dist < 0) dist = 0.0f - dist;
		if(dist > 1.0f) return;
		index = y*cbw + x;
		
		val = (int)((0xff&b[index])*dist + col*(1.0f-dist));

		if(val > 255) val = 255;
		else if(val < 0) val = 0;
		
		b[index] = (byte)(0xff&val);
	}

	boolean antialias = false;

	public void circ(int cx, int cy, int rad)
	{
		int ir, ix, iy, ig, idgr,idgd;
		ir = rad;
		ix = 0; iy = ir;
		ig=2*ir-3;
		idgr = -6; idgd = 4*ir-10;

		intensifyPixel(cx+ir,cy,0);
		intensifyPixel(cx-ir,cy,0);
		intensifyPixel(cx,cy+ir,0);
		intensifyPixel(cx,cy-ir,0);
		while(ix<=iy) {
			if (ig<0) {
				ig = ig+idgd;
				idgd = idgd-8;
				iy=iy-1;
			} else {
				ig = ig+idgr;
				idgd = idgd-4; 
			}
			idgr = idgr-4;
			ix = ix+1;
			intensifyPixel(ix+cx,iy+cy,0);
			intensifyPixel(cx+ix,cy-iy,0);
			intensifyPixel(cx-ix,cy-iy,0);
			intensifyPixel(cx-ix,cy+iy,0);
			intensifyPixel(cx+iy,cy+ix,0);
			intensifyPixel(cx-iy,cy+ix,0);
			intensifyPixel(cx+iy,cy-ix,0);
			intensifyPixel(cx-iy,cy-ix,0);
		}
	}
	/*
	public void line(int ox1, int oy1, int ox2, int oy2) {
		int dx, dy, incrE, incrNE, d, incy, incx, which;
		if(ox1==ox2) {
			if(oy1 < oy2) { } 
			else { incy = oy2; oy2 = oy1; oy1 = incy;}
			for(;oy1<=oy2;oy1++) {
				intensifyPixel(ox1, oy1, 0);
			}
			return;
		}
		// do horizontal line
		if (oy1==oy2) {
			if(ox1 < ox2) { }
			else { incx = ox2; ox2 = ox1; ox1= incx;}
			for(;ox1<=ox2;ox1++) {
				intensifyPixel(ox1, oy1, 0);
			}
			return;
		}

		dy = oy2-oy1;
		dx = ox2-ox1;
		
		if ((dy>0&&dx>0&&dy<=dx)||(dy<0&&dx<0&&dy>=dx)) which = 1;
		else if ((dy>0&&dx>0&&dy>dx) || (dy<0&&dx<0&&dy<dx)) which = 2;
		else if ((dy>0&&dx<0&&dy>-dx)||(dy<0&&dx>0&&-dy>dx)) which = 3;
		else which = 4;
		
		if(((which==1 || which==2 ||which==4) && ox1 > ox2) || ((which==3) && ox1 < ox2)) {
			incx = ox2; incy = oy2;
			ox2 = ox1; oy2 = oy1;
			ox1 = incx; oy1= incy;
		}
		else {
		}
		dx = ox2 - ox1;
		dy = oy2 - oy1;

		incx = incy= 0;
				
		if (which==1) {
			d = 2 * dy - dx;
			incy = 1;
			incrE = 2*dy;
			incrNE = 2*(dy-dx);
		}
		else if(which==2) {
			d = 2 * dx - dy;
			incx = 1;
			incrE = 2*dx;
			incrNE = 2*(dx-dy);
		}
		else if(which==3) {
			d = -2 * dx - dy;
			incx = -1;
			incrE = -2*dx;
			incrNE = -2*(dx+dy);
		}
		else {
			d = -2 * dy - dx;
			incy = -1;
			incrE = -2*dy;
			incrNE = -2*(dy+dx);
		}
		if(which==1 || which==4) {
			intensifyPixel(ox1, oy1, 0);
			while(ox1 < ox2) {
				if(d<0) {
					d += incrE;
					++ox1;
				}
				else {
					d += incrNE;
					++ox1;
					oy1+=incy;
				}
				intensifyPixel(ox1, oy1, 0);
			}
		}
		else {
			intensifyPixel(ox1, oy1, 0);
			while(oy1 < oy2) {
				if(d<0) {
					d += incrE;
					++oy1;
				}
				else {
					d += incrNE;
					++oy1;
					ox1+=incx;
				}
				intensifyPixel(ox1, oy1, 0);
			}
		}
	}
	*/
	public void line(int ox1, int oy1, int ox2, int oy2) {
            
		int dx, dy, incrE, incrNE, d, x, y, twoV, sdx=0, sdy=0;
		float invDenom, twoDX, scratch, slope;
		int x1, x2, y1, y2, incy=0, incx=0, which;
		boolean backwards = false, slopeDown = false;
   
/*      gi.setColor(Color.black);
      gi.drawLine(ox1,oy1,ox2,oy2); if (true) return;
  */    
	//	System.out.println(ox1+"/"+(cbh1-oy1)+"/"+ox2+"/"+(cbh1-oy2));
		// HEY, this is not doing clipping ... this is bad!!!!
		
        /* first do horizontal line */
		if(ox1==ox2) {
			x = ox1;
			if(oy1 < oy2) { y1 = oy1; y2 = oy2; }
			else { y1 = oy2; y2 = oy1; }
			for(y=y1;y<=y2;y++) {
				intensifyPixel(x, y, 0);
			}
			return;
		}
		slope = (float)(oy2 - oy1)/(float)(ox2 - ox1);
		/* check for which 1, 0 <= slope <= 1 */
		if(slope >= 0 && slope <= 1) which = 1;
		else if(slope > 1) which = 2;
		else if(slope < -1) which = 3;
		else which=4;
		if(((which==1 || which==2 ||which==4) && ox1 > ox2) || ((which==3) && ox1 < ox2)) {
			x1 = ox2;
			x2 = ox1;
			y1 = oy2;
			y2 = oy1;
		}
		else {
			x1 = ox1;
			y1 = oy1;
			x2 = ox2;
			y2 = oy2;
		}
		dx = x2 - x1;
		dy = y2 - y1;
		if(which==1) {
			sdx = dx;
			d = 2 * dy - dx;
			incy = 1;
			incrE = 2*dy;
			incrNE = 2*(dy-dx);
		}
		else if(which==2) {
			sdy = dy;
			d = 2 * dx - dy;
			incx = 1;
			incrE = 2*dx;
			incrNE = 2*(dx-dy);
		}
		else if(which==3) {
			sdy = -dy;
			d = -2 * dx - dy;
			incx = -1;
			incrE = -2*dx;
			incrNE = -2*(dx+dy);
		}
		else /*if(which == 4)*/ {
			sdx = -dx;
			d = -2 * dy - dx;
			incy = -1;
			incrE = -2*dy;
			incrNE = -2*(dy+dx);
		}
		if(which==1 || which==4) {
			twoV = 0;
			invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
			twoDX = 2 * sdx * invDenom;
			x = x1;
			y = y1;
			if(antialias) {
				intensifyPixel(x, y, 0);
				intensifyPixel(x, y+1, twoDX);
				intensifyPixel(x, y-1, twoDX);
			}
			else
				intensifyPixel(x, y, 0);
			while(x < x2) {
				if(d<0) {
					twoV = d + dx;
					d += incrE;
					++x;
				}
				else {
					twoV = d - dx;
					d += incrNE;
					++x;
					y+=incy;
				}
				scratch = twoV * invDenom;
				if(antialias) {
					intensifyPixel(x, y, scratch);
					intensifyPixel(x, y+1, twoDX - scratch);
					intensifyPixel(x, y-1, twoDX + scratch);
				}
				else
					intensifyPixel(x, y, 0);
			}
		}
		else {
			twoV = 0;
			invDenom = 1.0f / (2.0f * (float)Math.sqrt(dx*dx + dy*dy));
			twoDX = 2 * sdy * invDenom;
			x = x1;
			y = y1;
			if(antialias) {
				intensifyPixel(x, y, 0);
				intensifyPixel(x+1, y, twoDX);
				intensifyPixel(x-1, y, twoDX);
			}
			else
				intensifyPixel(x, y, 0);
			while(y < y2) {
				if(d<0) {
					twoV = d + dy;
					d += incrE;
					++y;
				}
				else {
					twoV = d - dy;
					d += incrNE;
					++y;
					x+=incx;
				}
				scratch = twoV * invDenom;
				if(antialias) {
					intensifyPixel(x, y, scratch);
					intensifyPixel(x+1, y, twoDX - scratch);
					intensifyPixel(x-1, y, twoDX + scratch);
				}
				else
					intensifyPixel(x, y, 0);
			}
		}
	}
	
}

class pxg24 extends pxg {
	DirectColorModel dm;
	int []v;
	int []lbuf; // one buffer for line of pixels
	
	public pxg24(int w, int h, Panel p)
	{
		super(w,h,p );
		dm = new DirectColorModel(24,0xff0000,0xff00,0xff);
		v = new int[cbt];
		for(int i = 0; i < cbt; i++) v[i] = 0xff000000;
		ms = new MemoryImageSource(cbw,cbh,dm,v,0,cbw);
		ms.setAnimated(true);
		lbuf = new int[cbw];
		im = p.createImage(ms);
		mode = pxg_mode24;
		System.out.println("--> using pxg24");
/*		ms = new MemoryImageSource(cbw,cbh,v,0,cbw);
		ms.newPixels(v,dm,0,cbw); // replace the model
		ms.setAnimated(true);
*/	}

	int col; // red, green, blue
	public void setrgb(int r, int g, int b)
	{
		col = (r<<16)|(g<<8)|b;
	}	
	public void fillRect(int x, int y, int w, int h)
	{
		if (x<0) x = 0; if (y<0) y= 0;
		if (x>=cbw) x = cbw-1; if (y>=cbh) y = cbh-1;
		if (x+w<cbw) {} else w = cbw-x;
		if (y+h<cbh) {} else h = cbh-y;
		int i,j,x2 = x+w, y2 = y+h, k;
		for(i=x; i<x2; i++) 
			lbuf[i] = col;
		for(j=y, k = y*cbw+x; j<y2; j++, k+= cbw)
			System.arraycopy(lbuf,x,v,k,w);
	}
}